#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>

#include "serial.h"
#include "spi.h"

#define	DEFAULT_BRIGHTNESS	128

int main(void)
{
init_printf();

printf("Init. SPI\n");
spi_init(1);
_delay_ms(1000);

spi_initcs(&SPI_DDR_DISPLAY,SPI_BIT_DISPLAY);
spi_initcs(&SPI_DDR_MATRIX,SPI_BIT_MATRIX);
spi_unselect(&SPI_PORT_DISPLAY,SPI_BIT_DISPLAY);
spi_unselect(&SPI_PORT_MATRIX,SPI_BIT_MATRIX);

printf("Start SPI Tests\n");




/**Tableaux à destinations des afficheurs 7 segments**/
// A, B, C, D, E, F
// Cependant, nous sélectionnons au préalable les afficheurs 5 puis 4, 3, 2, 1, 0
//ce qui affiche finalement F, E, D, C, B, A
uint8_t display7Segments1[] = {5, 'A', 4, 'B', 3, 'C', 2, 'D', 1, 'E', 0, 'F'};
uint8_t display7Segments2[] = {0, 'A', 1, 'B', 2, 'C', 3, 'D', 4, 'E', 5, 'F'};
/**Tableaux à destinations de la matrice de LEDs**/
// B, O, N, J, O, U, R
uint8_t matrice[] = {'B', 'O', 'N', 'J', 'O', 'U', 'R'};
uint8_t rotationmessage=0;

//uint8_t reponse;

/**Fonctionnement séquentiel de la maquette**/
while(1){

    /*Permet l'envoie d'un tableau sur les afficheurs 7 segments*/
    spi_select(&SPI_PORT_DISPLAY,SPI_BIT_DISPLAY);//sélection du uC controlant les afficheurs 7 segments
    _delay_ms(5);
    for(int i=0;i<12;i++) //parcours du tableau pour l'envoie des valeurs
    {
      if(rotationmessage)
      {
        spi_exch(display7Segments1[i]);
        _delay_ms(15); // un temps inférieur à 15 ms fait saturer la communication et décale les valeurs que l'on envoie
      }
      else
      {
        spi_exch(display7Segments2[i]);
        _delay_ms(15); // un temps inférieur à 15 ms fait saturer la communication et décale les valeurs que l'on envoie
      }
    }
      spi_unselect(&SPI_PORT_DISPLAY,SPI_BIT_DISPLAY); //déselection du uC
      _delay_ms(150);
    
    //Permet l'envoie d'un message sur la matrice de LEDs
    spi_select(&SPI_PORT_MATRIX,SPI_BIT_MATRIX);//sélection du uC controlant la matrice de LEDs
    _delay_ms(5);
    for(int i=0;i<7;i++) //parcours du tableau pour l'envoie du message
    {
      spi_exch(matrice[i]);
      _delay_ms(800); // temps permettant d'avoir le temps de lire correctement l'enchainement des caractères
    }
    
    /**test nouveau codage des caractères de la matrice**/
    //spi_exch('R');
    //_delay_ms(800); // temps permettant d'avoir le temps de lire correctement l'enchainement des caractères
    /**/
    
    spi_unselect(&SPI_PORT_MATRIX,SPI_BIT_MATRIX); //déselection du uC
    //_delay_ms(150);
    
    rotationmessage = (rotationmessage+1)%2;
  }

return 0;
}
